import { PipeTransform, Provider, Type } from '@angular/core';
import { AngularModule } from './angular-module';
import { MockCache } from './mock-cache';
export declare class TestSetup<TTestTarget> {
    readonly testComponentOrService: Type<TTestTarget>;
    readonly testModule: AngularModule;
    readonly dontMock: any[];
    readonly mocks: Map<any, any>;
    readonly staticMocks: Map<any, any>;
    readonly moduleReplacements: Map<AngularModule, AngularModule>;
    readonly mockPipes: Map<PipeTransform | Type<PipeTransform>, Function>;
    readonly mockCache: MockCache;
    readonly providers: Provider[];
    readonly declarations: Type<any>[];
    readonly imports: AngularModule[];
    readonly withStructuralDirectives: Map<Type<any>, boolean>;
    alwaysRenderStructuralDirectives: boolean;
    constructor(testComponentOrService: Type<TTestTarget>, testModule?: AngularModule);
}
