"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.jasmineFramework = void 0;
exports.jasmineFramework = {
    createSpy: () => jasmine.createSpy(),
    isSpy: (mockFunction) => jasmine.isSpy(mockFunction),
    spyOn(object, method, mockImplementation) {
        const spy = spyOn(object, method);
        if (!mockImplementation) {
            return spy.and.callThrough();
        }
        this.mockImplementation(spy, mockImplementation);
        return spy;
    },
    mockImplementation(spy, mockImplementation) {
        spy.and.callFake(mockImplementation);
    },
    resetSpy(spy) {
        spy.calls.reset();
    },
};
//# sourceMappingURL=jasmine.framework.js.map