"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getProviderName = void 0;
function getProviderName(provider) {
    if (typeof provider === 'string') {
        return provider;
    }
    if (typeof provider === 'function') {
        return provider.name;
    }
    if ('provide' in provider) {
        return getProviderName(provider.provide); // Recursion
    }
    // This works well with InjectionTokens
    return provider.toString();
}
exports.getProviderName = getProviderName;
//# sourceMappingURL=get-provider-name.js.map