"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.injectRootProviders = void 0;
const reflect_1 = require("./reflect");
const core_1 = require("@angular/core");
const testing_1 = require("@angular/core/testing");
const mock_provider_1 = require("./mock-provider");
const injectRootProviders = (setup) => {
    setup.mocks.forEach((mock, thingToMock) => {
        if (!reflect_1.reflect.isDirective(thingToMock)) {
            if (thingToMock instanceof core_1.InjectionToken) {
                testing_1.TestBed.overrideProvider(thingToMock, { useValue: mock });
            }
            else {
                const provider = (0, mock_provider_1.mockProvider)(thingToMock, setup);
                testing_1.TestBed.overrideProvider(thingToMock, {
                    useValue: provider.useValue,
                    useFactory: provider.useFactory,
                    deps: provider.deps,
                });
            }
        }
    });
};
exports.injectRootProviders = injectRootProviders;
//# sourceMappingURL=inject-root-providers.js.map