"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mockWithInputsOutputsAndStubs = void 0;
const core_1 = require("@angular/core");
const reflect_1 = require("./reflect");
const mock_with_stubs_1 = require("../models/mock-with-stubs");
const mockWithInputsOutputsAndStubs = (componentOrDirective, stubs) => {
    const { inputs, outputs } = reflect_1.reflect.getInputsAndOutputs(componentOrDirective);
    class Mock extends mock_with_stubs_1.MockWithStubs {
        constructor() {
            super(stubs);
            outputs.forEach(({ propertyName }) => Object.assign(this, { [propertyName]: new core_1.EventEmitter() }));
        }
    }
    inputs.forEach(({ propertyName, alias }) => (0, core_1.Input)(alias)(Mock.prototype, propertyName));
    outputs.forEach(({ propertyName, alias }) => (0, core_1.Output)(alias)(Mock.prototype, propertyName));
    return Mock;
};
exports.mockWithInputsOutputsAndStubs = mockWithInputsOutputsAndStubs;
//# sourceMappingURL=mock-with-inputs-and-outputs-and-stubs.js.map