"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isEnvironmentProviders = exports.isClass = exports.isPipeTransform = exports.isTypeProvider = exports.isClassProvider = exports.isFactoryProvider = exports.isExistingProvider = exports.isValueProvider = exports.isModuleWithProviders = void 0;
const core_1 = require("@angular/core");
const reflect_1 = require("./reflect");
function isModuleWithProviders(thing) {
    const key = 'ngModule';
    return !!thing && typeof thing === 'object' && key in thing;
}
exports.isModuleWithProviders = isModuleWithProviders;
function isValueProvider(provider) {
    const key = 'useValue';
    return typeof provider === 'object' && key in provider;
}
exports.isValueProvider = isValueProvider;
function isExistingProvider(provider) {
    const key = 'useExisting';
    return typeof provider === 'object' && key in provider;
}
exports.isExistingProvider = isExistingProvider;
function isFactoryProvider(provider) {
    const key = 'useFactory';
    return typeof provider === 'object' && key in provider;
}
exports.isFactoryProvider = isFactoryProvider;
function isClassProvider(provider) {
    const key = 'useClass';
    return typeof provider === 'object' && key in provider;
}
exports.isClassProvider = isClassProvider;
function isTypeProvider(provider) {
    return typeof provider === 'function';
}
exports.isTypeProvider = isTypeProvider;
function isPipeTransform(thing) {
    return reflect_1.reflect.isPipe(thing);
}
exports.isPipeTransform = isPipeTransform;
const isClass = (thing) => {
    return typeof thing === 'function';
};
exports.isClass = isClass;
/**
 * Angular explicitly obscured the EnvironmentProviders type that require hard-casting to unbox
 */
const isEnvironmentProviders = (thing) => (0, core_1.ɵisEnvironmentProviders)(thing);
exports.isEnvironmentProviders = isEnvironmentProviders;
//# sourceMappingURL=type-checkers.js.map